(function() {
    var __QZAppExternal = window.__QZAppExternal = window.QZAppExternal || {getCommands: function() {
        }};
    var QZAppExternal = window.QZAppExternal = {};
    var androidGetCmdTimer;
    var cbFnId = 0;
    var ua = navigator.userAgent;
    var isQzone = ua.match(/qzone/i);
    var android = ua.match(/(Android)[\s\/]+([\d.]+)/);
    var ipad = ua.match(/(iPad).*OS\s([\d_]+)/);
    var iphone = !ipad && ua.match(/(iPhone\sOS)\s([\d_]+)/);
    var ipod = !ipad && !iphone && ua.match(/(iPod).*OS\s([\d_]+)/);
    var ie = ua.match(/(MSIE)\s([\d.]+)/);
    var os = {}, util = {}, event =
    {};
    var hasNotify = false;
    try {
        window.external.notify("");
        hasNotify = true
    } catch (e) {
    }
    if (ie && hasNotify)
        os.ie = true, os.version = ie[2];
    else if (android)
        os.android = true, os.version = android[2];
    else if (iphone)
        os.ios = os.iphone = true, os.version = iphone[2].replace(/_/g, ".");
    else if (ipad)
        os.ios = os.ipad = true, os.version = ipad[2].replace(/_/g, ".");
    else if (ipod)
        os.ios = os.ipod = true, os.version = ipod[2].replace(/_/g, ".");
    event = {fireEvent: function(type, data) {
            var e = document.createEvent("Events");
            e.initEvent(type, false, false);
            e.data = data;
            document.dispatchEvent(e)
        }};
    util = {
        whiteList : [  //可以走mqq.invoke的白名单列表
            "vibrate","startAccelerometer","stopAccelerometer","getDeviceInfo","getConn"
        ],

        namespaceList :  [  //命名空间列表
            "sensor","app","data","media","device"
        ],

        methodList : [  //方法列表
            "vibrate","startAccelerometer","stopAccelerometer","startCompass","stopCompass","getLocation", //sensor 6
            "isAppInstalled","launchApp", //app 2
            "getDeviceInfo","getNetworkInfo" //device 
        ],

        isFn: function(fn) {
            return typeof fn === "function"
        },
        execFn: function(fn, data) {
            if (QZAppExternal._util.isFn(fn))
                return fn.call(window, data);
            else if (typeof fn === "string")
                if (/\./.test(fn)) {
                    var fnNameArr = fn.split(".");
                    var tmp = window;
                    var fnNameStr = "window";
                    for (var i = 0, l = fnNameArr.length; i < l; i++) {
                        var cur = fnNameArr[i];
                        tmp = tmp[cur];
                        fnNameStr += '["' + cur + '"]'
                    }
                    if (tmp)
                        if (fn.indexOf("__") === 0)
                            return eval(fnNameStr + "(" + data + ");");
                        else
                            return tmp.call(window, data)
                } else
                    return window[fn].call(window,
                    data)
        },
        log: function(msg) {
            window.console && window.console.log && window.console.log(msg)
        },
        parseData: function(data) {
            try {
                if (location.href.indexOf("/widget/mobile/test/index.html") != -1)
                    console.log(data);
                data = JSON.parse(data)
            } catch (e) {
                data = {code: "1001",message: "json parse error",data: {}}
            }
            return data
        },
        requestWithIframe: function(url) {
            var tmpIframe = document.createElement("iframe");
            tmpIframe.setAttribute("width", 0);
            tmpIframe.setAttribute("height", 0);
            tmpIframe.setAttribute("style", "display: none;");
            document.body.appendChild(tmpIframe);
            tmpIframe.src = url;
            setTimeout(function() {
                document.body.removeChild(tmpIframe);
                androidIframe = null
            }, 1E3)
        },
        transformUrl :function (fnName, params, cbFn){
            //jsbridge://[["QZAppExternal.vibrate",{"time":3000},""]]
            //jsbridge://sensor/vibrate?p={"time":3000,"callback":5}
            //
            //mqq.invoke(ns, method, argus, callback)
            var wl = this.whiteList;
            var nl = this.namespaceList;
            var ml = this.methodList;
            var bIsWhite;
            for(var i=0,len=wl.length; i<len; i++){
                if(fnName == wl[i]){
                    //在白名单启用mqq.invoke方式
                    bIsWhite = true;
                    if(fnName == wl[0]){
                        //vibrate
                        mqq.invoke(nl[0],fnName,params,cbFn);
                    }else if(fnName == wl[1]){
                        //startAccelerometer
                        mqq.invoke(nl[0],fnName,params,cbFn);
                    }else if(fnName == wl[2]){
                        //startAccelerometer
                        mqq.invoke(nl[0],fnName,params,cbFn);
                    }else if(fnName == wl[3]){
                        //getDeviceInfo
                        mqq.invoke(nl[4],fnName,params,cbFn);
                    }else if(fnName == wl[4]){
                        //getConn && getNetworkInfo
                        mqq.invoke(nl[4],ml[9],params,cbFn);
                    }
                    break;
                }
            }
            //如果不在白名单，走老逻辑
            if(!bIsWhite){
                QZAppExternal.exec(fnName, params, cbFn)
            }
            
        }

    };
    QZAppExternal._os = os;
    QZAppExternal._event = event;
    QZAppExternal._util = util;
    QZAppExternal.domReady = false;
    QZAppExternal.cmdsQuene = [];
    QZAppExternal.getCommands = function() {
        var cmds = "";
        if (QZAppExternal.domReady && QZAppExternal.cmdsQuene.length > 0)
            if (QZAppExternal._os.android) {
                cmds = JSON.stringify(QZAppExternal.cmdsQuene.shift());
                while (cmds.length < 10 * 1E3 && QZAppExternal.cmdsQuene.length)
                    cmds += "," + JSON.stringify(QZAppExternal.cmdsQuene.shift());
                debugger;
                QZAppExternal._util.requestWithIframe("jsbridge://" + encodeURIComponent("[" + cmds + "]"));
                if (QZAppExternal.cmdsQuene.length)
                    setTimeout(QZAppExternal.getCommands, 200)
            } else {
                cmds = JSON.stringify(QZAppExternal.cmdsQuene);
                QZAppExternal.cmdsQuene.length = 0
            }
        return cmds
    };
    QZAppExternal.exec = function(fnName, params, cbFn) {
        var cbFnName = cbFn ? "cbFn" + ++cbFnId : "";
        var cmd = ["QZAppExternal." + fnName, params, cbFn ? "QZAppExternal." + fnName + "." + cbFnName : ""];
        if (cbFn) {
            QZAppExternal[fnName] = QZAppExternal[fnName] || {};
            QZAppExternal[fnName][cbFnName] =
            function(data) {
                if (typeof data === "string")
                    data = QZAppExternal._util.parseData(data);
                var ___persist___ = false;
                if (data && data.data) {
                    ___persist___ = data.data.___persist___;
                    delete data.data.___persist___
                }
                QZAppExternal._util.execFn(cbFn, data);
                if (!___persist___) {
                    QZAppExternal[fnName][cbFnName] = null;
                    delete QZAppExternal[fnName][cbFnName]
                }
            }
        }
        if (QZAppExternal._os.android) {
            QZAppExternal.cmdsQuene.push(cmd);
            if (QZAppExternal.cmdsQuene.length == 1)
                androidGetCmdTimer = setTimeout(function() {
                    QZAppExternal.getCommands()
                },
                200)
        } else if (QZAppExternal._os.ios)
            QZAppExternal.cmdsQuene.push(cmd);
        else if (QZAppExternal._os.ie)
            window.external.notify(JSON.stringify(cmd))
    };
    QZAppExternal._addInterface = function(fnName, opts) {
        QZAppExternal[fnName] = QZAppExternal[fnName] || function(cbFn, params) {
            var cbFnName = "cbFn" + Math.floor(Math.random() * 1E6);
            if (typeof cbFn === "object" && !params) {
                params = cbFn;
                cbFn = null
            }
            QZAppExternal._util.transformUrl(fnName, params, cbFn);
        }
    };


    QZAppExternal._addInterface("getQUA");
    QZAppExternal.getQUAEx = function() {
        var quaArr = [];
        return function(cbFn) {
            if (QZAppExternal._util.isFn(cbFn))
                if (quaArr.length)
                    cbFn({code: 0,
                        message: "success",data: quaArr});
                else
                    QZAppExternal.getQUA(function(data) {
                        if (data && data.data) {
                            quaArr = data.data.split("_");
                            cbFn({code: 0,message: "success",data: quaArr})
                        } else
                            cbFn(data)
                    })
        }
    }();
    QZAppExternal._addInterface("getUserInfo");
    QZAppExternal._addInterface("getConn");
    QZAppExternal._addInterface("refresh");
    QZAppExternal._addInterface("data");
    var _sendData = QZAppExternal.data;
    QZAppExternal.data = function() {
        var seg = 100 * 1E3;
        return function(obj) {
            if (obj.total == 0)
                if (obj.content.length > seg) {
                    var end = seg;
                    var len =
                    obj.content.length;
                    var total = Math.ceil(len / seg);
                    var idx = 0;
                    while (idx < total) {
                        _sendData({key: obj.key,total: total,current: idx,type: obj.type,content: obj.content.substring(idx * seg, end < len ? end : len),params: obj.params});
                        idx++;
                        end += seg
                    }
                } else {
                    obj.total = 1;
                    obj.current = 0;
                    _sendData(obj)
                }
            else
                _sendData(obj)
        }
    }(), QZAppExternal._addInterface("call");
    QZAppExternal._addInterface("finish");
    QZAppExternal._addInterface("setOrientation");
    QZAppExternal.setOrientationEx = function(isVertical) {
        QZAppExternal.setOrientation({isVertical: isVertical})
    };
    var _finish = QZAppExternal.finish;
    QZAppExternal.finish = function(obj) {
        QZAppExternal.getQUAEx(function(data) {
            if (!data.data || !data.data[3] || parseFloat(data.data[3]) < 4.5)
                _finish(obj);
            else {
                QZAppExternal.data({key: "finish_object",total: 0,type: "base64",content: obj.base64});
                delete obj.base64;
                obj.photos = ["finish_object"];
                QZAppExternal.call({key: "add_mood",type: "operation",subtype: "mood",params: obj})
            }
        })
    };
    QZAppExternal._addInterface("qzoneMusic");
    QZAppExternal._addInterface("qzoneBuyVip");
    QZAppExternal._addInterface("openVip");
    QZAppExternal._addInterface("closeWebview");
    QZAppExternal._addInterface("callSchema");
    QZAppExternal._addInterface("setTopbar");
    QZAppExternal._addInterface("getLocation");
    QZAppExternal._addInterface("startAccelerometer");
    QZAppExternal._addInterface("stopAccelerometer");
    QZAppExternal._addInterface("getDeviceInfo");
    QZAppExternal._addInterface("vibrate");
    QZAppExternal._addInterface("preloadSound");
    QZAppExternal._addInterface("playLocalSound");
    QZAppExternal._addInterface("playLocalBackSound");
    QZAppExternal._addInterface("stopSound");
    QZAppExternal._addInterface("stopBackSound");
    QZAppExternal._addInterface("reportScore");
    QZAppExternal._addInterface("loadgame");
    QZAppExternal._addInterface("isAppInstallIOS");
    QZAppExternal._addInterface("httpProxy");
    QZAppExternal._addInterface("setShare");
    QZAppExternal._addInterface("registerCallback");
    QZAppExternal._addInterface("webviewConsole");
    function AndroidAppApiExec(cmd, data, callback) {
        if (QZAppExternal.appApi) {
            data = data || {};
            data.type = cmd;
            QZAppExternal.appApi(callback, data)
        }
    }
    QZAppExternal.isAppInstall =
    function(packageName, callback) {
        if (QZAppExternal._os.android)
            AndroidAppApiExec("isAppInstall", {packageName: packageName}, callback);
        if (QZAppExternal._os.ios)
            QZAppExternal.isAppInstallIOS(callback, {"schema": packageName})
    };
    QZAppExternal.getAppState = function(url, callback) {
        AndroidAppApiExec("getDownloadState", {url: url}, callback)
    };
    QZAppExternal.listenDownloadState = function() {
        AndroidAppApiExec("listenDownloadState")
    };
    QZAppExternal.cancelListenDownloadState = function() {
        AndroidAppApiExec("cancelListenDownloadState")
    };
    QZAppExternal.startDownloadApp = function(data) {
        if (typeof data == "string")
            AndroidAppApiExec("startDownload", {url: data});
        else
            AndroidAppApiExec("startDownload", data)
    };
    QZAppExternal.installApp = function(path, callback) {
        AndroidAppApiExec("installApp", {path: path}, callback)
    };
    QZAppExternal.pauseDownloadApp = function(url) {
        AndroidAppApiExec("pauseDownload", {url: url})
    };
    QZAppExternal.cancelDownloadApp = function(url) {
        AndroidAppApiExec("cancelDownload", {url: url})
    };
    QZAppExternal._addInterface("getPageVisibility");
    QZAppExternal.fireEvent =
    function(params) {
        if (typeof params === "string")
            params = QZAppExternal._util.parseData(params);
        var type = params.type;
        var data = params.data;
        if (type)
            QZAppExternal._event.fireEvent(type, data)
    };
    QZAppExternal.getPlatform = function() {
        if (isQzone && android)
            return 1;
        else if (isQzone && (ipad || iphone || ipod))
            return 2;
        else
            return 3
    };
    var loadFns = [];
    var whenWindowReady = function() {
        for (var i = 0, len = loadFns.length; i < len; i++)
            loadFns[i].apply(window)
    };
    QZAppExternal.ready = function(fn) {
        if (typeof fn == "function")
            if (QZAppExternal.domReady)
                fn.apply(window);
            else
                loadFns.push(fn)
    };
    QZAppExternal._addInterface("qzoneGameBar");
    if (QZAppExternal._os.android)
        QZAppExternal._addInterface("appApi");
    var bbsFrame;
    QZAppExternal.openBBS = function(url) {
        bbsFrame = null;
        if (!url)
            return false;
        bbsFrame = document.createElement("iframe");
        bbsFrame.style.cssText = "width:100%;height:100%;position:absolute;left:0px;top:0px;background-color:white;z-index:99999;border:none;";
        bbsFrame.src = url + "&_close=true";
        document.body.appendChild(bbsFrame)
    };
    window.addEventListener("message", function(e) {
        var c =
        e && e.data;
        if (c == "close" && bbsFrame && bbsFrame.parentNode)
            bbsFrame.parentNode.removeChild(bbsFrame)
    }, false);
    (function() {
        if ("loaded|complete".indexOf(document.readyState) == -1)
            setTimeout(arguments.callee, 50);
        else {
            QZAppExternal.domReady = true;
            if (QZAppExternal._os.android)
                QZAppExternal.getCommands();
            whenWindowReady()
        }
    })();
    QZAppExternal.report = function() {
        var self = this
    };
    QZAppExternal.report.string = function() {
        var StringReport = function(arg) {
            var tmp = {commandid: "app" + arg.gameid,appid: "1000019",frequency: 3,dtype: 1,
                odetails: arg.string};
            var report = {mm_timestat: [parseParam(tmp)]};
            var base = {locuin: arg.openid || "0",touin: arg.openid || "0",deviceinfo: arg.deviceinfo || "0",dnstime: arg.dnstime || "0",httptime: arg.httptime || "0",tcptime: arg.tcptime || "0",os: arg.os || "0",sdkversion: arg.sdkversion || "0",sdkid: arg.sdkid || "0",device: arg.device || "0",releaseversion: arg.releaseversion || "0",r: Math.random()};
            var baseStr = parseParam(base);
            var img = new Image;
            img.src = "http://mmspeed.qq.com/client/report?report_data=" + encodeURIComponent(JSON.stringify(report)) +
            "&comm_data=" + encodeURIComponent(baseStr)
        };
        function parseParam(obj) {
            var ret = [];
            for (var i in obj)
                ret.push(i + "=" + encodeURIComponent(obj[i]));
            return ret.join("&")
        }
        return StringReport
    }();
    QZAppExternal.report.returnCode = function() {
        var commurl = "http://c.isdspeed.qq.com/code.cgi", urlParse = /^http:\/\/([\s\S]*?)(\/[\s\S]*?)(?:\?|$)/;
        var s = "";
        var index = 0;
        var reportTimer;
        var img;
        var MAX_URL_LENGTH = 900;
        function valueStat(arg) {
            var defaultConf = {domain: arg.domain,cgi: arg.cgi.replace(urlParse, ""),type: arg.type,code: arg.code,
                time: arg.time,rate: arg.rate || 10};
            if (Math.random() > 1 / defaultConf.rate)
                return;
            setTimeout(function() {
                pushData(defaultConf)
            }, 0)
        }
        var pushData = function(data) {
            index++;
            var param = [];
            param.push([index, "_", 1, "=", data.domain].join(""));
            param.push([index, "_", 2, "=", data.cgi].join(""));
            param.push([index, "_", 3, "=", data.type].join(""));
            param.push([index, "_", 4, "=", data.code].join(""));
            param.push([index, "_", 5, "=", data.time].join(""));
            param.push([index, "_", 6, "=", data.rate].join(""));
            s += "&" + param.join("&");
            clearTimeout(reportTimer);
            if (s.length >= MAX_URL_LENGTH)
                report();
            else
                reportTimer = setTimeout(function() {
                    report()
                }, 2500)
        };
        var report = function() {
            if (!s)
                return;
            img = new Image;
            var url = commurl + "?key=domain,cgi,type,code,time,rate&r=" + Math.random() + "&" + s;
            img.src = url;
            s = "";
            index = 0
        };
        return valueStat
    }()
})();

try {
    (function(_w) {
        _w._javascript_file_map = _w._javascript_file_map || {};
        _w._javascript_file_map['qzone/phone/m/v4/widget/mobile/jsbridge.js'] = true;
    })(window);
} catch (ign) {
}
/*  |xGv00|8e37c02a9577d5bc74779fcc4d7eb272 */